// C++ interface header file.
//
// Generated by SIP v3.0 on Sat Nov 24 01:08:35 2001
//
// Terms and Conditions
// 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// COPYRIGHT HOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
// IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// 
// Except as contained in this notice, the name of the copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from the
// copyright holder.

#ifndef _kioKDirLister_h
#define	_kioKDirLister_h

#line 22 "kdirlister.sip"
#include <kdirlister.h>
#line 37 "sipkioKDirLister.h"

#include "sipqtQObject.h"
#include "sipkioKDirNotify.h"
#include "sipqtQString.h"
#include "sipkdecoreKURL.h"
#include "sipkioKFileItem.h"
#include "sipkioKFileItemList.h"
#include "sipkioKIOListJob.h"
#include "sipkdecoreKURLList.h"
#include "sipkioKIOJob.h"
#include "sipkioKIOUDSEntryList.h"
#include "sipkioKIOUDSEntry.h"


extern SIP_IMPORT PyObject *sipClass_KDirLister;
extern SIP_IMPORT PyMethodDef sipClassAttrTab_KDirLister[];

extern SIP_IMPORT const void *sipCast_KDirLister Py_PROTO((const void *,PyObject *));
extern SIP_IMPORT PyObject *sipNew_KDirLister Py_PROTO((PyObject *,PyObject *));


class SIP_IMPORT sipKDirLister : public KDirLister
{
public:
	sipKDirLister(bool);
	~sipKDirLister();
	QValueList<QCString> functions();
	QValueList<QCString> interfaces();
	bool processDynamic(const QCString&,const QByteArray&,QCString&,QByteArray&);
	bool process(const QCString&,const QByteArray&,QCString&,QByteArray&);
	void childEvent(QChildEvent *);
	void timerEvent(QTimerEvent *);
	void removeChild(QObject *);
	void insertChild(QObject *);
	void setName(const char *);
	bool eventFilter(QObject *,QEvent *);
	bool event(QEvent *);
	bool matchesFilter(const KFileItem *) const;
	static bool sipVH_matchesFilter(const sipMethodCache *,sipThisType *,int,const KFileItem *);
	KFileItem * createFileItem(const KIO::UDSEntry&,const KURL&,bool);
	static KFileItem * sipVH_createFileItem(const sipMethodCache *,sipThisType *,int,const KIO::UDSEntry&,const KURL&,bool);
	void FileRenamed(const KURL&,const KURL&);
	void FilesChanged(const KURL::List&);
	void FilesRemoved(const KURL::List&);
	void FilesAdded(const KURL&);
	bool showingDotFiles() const;
	static bool sipVH_showingDotFiles(const sipMethodCache *,sipThisType *,int);
	void setShowingDotFiles(bool);
	static void sipVH_setShowingDotFiles(const sipMethodCache *,sipThisType *,int,bool);
	void updateDirectory(const KURL&);
	static void sipVH_updateDirectory(const sipMethodCache *,sipThisType *,int,const KURL&);
	bool setURL(const KURL&);
	static bool sipVH_setURL(const sipMethodCache *,sipThisType *,int,const KURL&);
	const KURL& url() const;
	static const KURL& sipVH_url(const sipMethodCache *,sipThisType *,int);
	void stop();
	static void sipVH_stop(const sipMethodCache *,sipThisType *,int);
	void openURL(const KURL&,bool,bool);
	static void sipVH_openURL(const sipMethodCache *,sipThisType *,int,const KURL&,bool,bool);

	// There is a public member function for every protected member
	// function visible from this class.

	const QObject * sipProtect_sender();
	void sipProtect_timerEvent(QTimerEvent *);
	void sipProtect_childEvent(QChildEvent *);
	bool sipProtect_matchesFilter(const KFileItem *);
	bool sipProtect_matchesMimeFilter(const KFileItem *);
	void sipProtect_slotResult(KIO::Job *);
	void sipProtect_slotEntries(KIO::Job *,const KIO::UDSEntryList&);
	void sipProtect_slotUpdateResult(KIO::Job *);
	void sipProtect_slotUpdateEntries(KIO::Job *,const KIO::UDSEntryList&);
	void sipProtect_slotRedirection(KIO::Job *,const KURL&);
	void sipProtect_slotDirectoryDirty(const QString&);
	void sipProtect_slotFileDirty(const QString&);
	void sipProtect_slotURLDirty(const KURL&);
	KFileItem * sipProtect_createFileItem(const KIO::UDSEntry&,const KURL&,bool);
	void sipProtect_forgetDirs();
	void sipProtect_deleteUnmarkedItems();
	bool sipProtect_validURL(const KURL&);
	void sipProtect_processPendingUpdates();

	// There is a public member function for every Qt signal that can be
	// emitted by this object.  This function is called by Python to emit
	// the signal.

	int sipEmit_destroyed(PyObject *sipArgs);
	int sipEmit_started(PyObject *sipArgs);
	int sipEmit_completed(PyObject *sipArgs);
	int sipEmit_canceled(PyObject *sipArgs);
	int sipEmit_redirection(PyObject *sipArgs);
	int sipEmit_clear(PyObject *sipArgs);
	int sipEmit_newItems(PyObject *sipArgs);
	int sipEmit_itemsFilteredByMime(PyObject *sipArgs);
	int sipEmit_deleteItem(PyObject *sipArgs);
	int sipEmit_refreshItems(PyObject *sipArgs);
	int sipEmit_closeView(PyObject *sipArgs);

	sipThisType *sipPyThis;

private:
	sipKDirLister(const sipKDirLister &);
	sipKDirLister &operator = (const sipKDirLister &);

	sipMethodCache sipPyMethods[24];
};

extern SIP_IMPORT KDirLister *sipForceConvertTo_KDirLister Py_PROTO((PyObject *,int *));

#endif
